SystemOrganization addCategory: #PhileasFogg!
SystemOrganization addCategory: #'PhileasFogg-Understanding'!

Object subclass: #PFButtonModel
	instanceVariableNames: 'controller modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:04'!
controller: aPhileasFoggController 

	controller := aPhileasFoggController! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:04'!
modelClass: anAddClassChangeClass 

	modelClass := anAddClassChangeClass! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 11/16/2011 21:05'!
nameOfModelClass

	^modelClass name! !

!PFButtonModel methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2011 11:20'!
performButtonAction

	controller removeAllUsersButtons.
	controller topicClass: modelClass  ! !

Object subclass: #PhileasFogg
	instanceVariableNames: 'topicClass classesReferencingTopicClass history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFogg methodsFor: 'history' stamp: 'hjo 12/29/2011 19:00'!
backHistory

	self history undo.
	self unhistoriedTopicClass: self history currentItem.
! !

!PhileasFogg methodsFor: 'users' stamp: 'hjo 1/8/2012 21:27'!
classesReferencingTopicClass
	^classesReferencingTopicClass ifNil: [
		classesReferencingTopicClass:=((topicClass theNonMetaClass asNode users collect: [ :each | each theClass theNonMetaClass ]) asSet
		copyWithout: topicClass) asSortedCollection: (AspectSortDescriptor ascendingBy: #name).
	].
	 ! !

!PhileasFogg methodsFor: 'history' stamp: 'hjo 12/29/2011 18:59'!
defaultHistory
 
	^UndoRedo new.  ! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:01'!
goSuperclass

	self topicClass superclass isNil ifFalse: [self topicClass: self topicClass superclass ]! !

!PhileasFogg methodsFor: 'history' stamp: 'hjo 11/27/2011 18:49'!
history 

	^history setDefault: #defaultHistory for: self withSetter: #history:! !

!PhileasFogg methodsFor: 'history' stamp: 'hjo 12/29/2011 18:55'!
history: anUndoRedo 

	history := anUndoRedo! !

!PhileasFogg methodsFor: 'instance variables' stamp: 'hjo 11/14/2011 11:32'!
instanceVariableNamesOfTopicClass
	^ topicClass instVarNames! !

!PhileasFogg methodsFor: 'superclass' stamp: 'hjo 11/14/2011 11:28'!
nameOfSuperclassOfTopicClass
	^ topicClass superclass name! !

!PhileasFogg methodsFor: 'about me' stamp: 'hjo 11/14/2011 11:28'!
nameOfTopicClass
	^ topicClass name! !

!PhileasFogg methodsFor: 'instance variables' stamp: 'hjo 11/14/2011 18:18'!
paragraphOfInstanceVariableNames

	^String streamContents: [:stream| self instanceVariableNamesOfTopicClass do: [:each| stream nextPutAll: each ] separatedBy: [stream cr]  ]  ! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2011 11:12'!
removeAllUsersButtons

	self changed: #pleaseRemoveAllUserButtons.  ! !

!PhileasFogg methodsFor: 'history' stamp: 'hjo 12/29/2011 19:01'!
restoreHistory

	self history redo.
	self unhistoriedTopicClass: self history currentItem.! !

!PhileasFogg methodsFor: 'accessing' stamp: 'hjo 11/14/2011 11:52'!
topicClass

	^ topicClass! !

!PhileasFogg methodsFor: 'accessing' stamp: 'hjo 12/29/2011 18:59'!
topicClass: aClass 

	self unhistoriedTopicClass: aClass.
	self history add: topicClass.
! !

!PhileasFogg methodsFor: 'history' stamp: 'hjo 11/27/2011 19:35'!
transcriptHistory

	Transcript print: self history;space; print: self history position; cr;flush.
! !

!PhileasFogg methodsFor: 'accessing' stamp: 'hjo 12/29/2011 18:58'!
unhistoriedTopicClass: aClass
	 
	topicClass := aClass.
	classesReferencingTopicClass := nil.
	self changed: #topicClass.
! !

Object subclass: #PhileasFoggController
	instanceVariableNames: 'window model contentView classNameTextMorph superclassButton userClassButtonesMorph buttons instanceVariablesMorph scrollPane point textMorph contentViewOfScrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2012 18:01'!
addModelItemsToWindowMenu: aMenu
	"Add model-related item to the window menu"

	super addModelItemsToWindowMenu: aMenu. 
	aMenu addLine.
	aMenu add: 'back history' translated target: self action: #backHistory.
	aMenu add: 'froward history' translated target: self action: #restoreHistory.! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2012 18:00'!
backHistory

	model backHistory! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/14/2011 17:32'!
classNameTextMorph

	^classNameTextMorph ifNil: [
		classNameTextMorph := model nameOfTopicClass asMorph.
		classNameTextMorph font:  (StrikeFont familyName: #Accuny size: 30).
		classNameTextMorph top: self superclassButton bottom + 10. 
		]! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/18/2011 20:14'!
contentView

	contentView isNil ifTrue: [
		contentView := Morph new. contentView extent: 300@500.
		contentView addMorph: self superclassButton.
		contentView addMorph: self classNameTextMorph.
		contentView addMorph: self scrollPane.
		].
	^contentView! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/17/2011 21:37'!
createButtonList

	| lastButton buttonHeights |
	userClassButtonesMorph removeAllMorphs.
	lastButton := nil.

	buttons := model classesReferencingTopicClass collect: 
	[:each| | button buttonModel |
		buttonModel := PFButtonModel new.
		buttonModel controller: model.
		buttonModel modelClass: each.
		button := PluggableButtonMorph on: buttonModel getState: nil action: #performButtonAction label: #nameOfModelClass.
		userClassButtonesMorph addMorph: button.
		lastButton 
			ifNil: [button topLeft: userClassButtonesMorph topLeft]
			ifNotNil: [button topLeft: lastButton bottomLeft].
		lastButton := button.
	].
	buttonHeights := buttons collect: #height.
	userClassButtonesMorph height: (buttonHeights isEmpty ifTrue: [30] ifFalse: [buttonHeights sum]).
! !

!PhileasFoggController methodsFor: 'defaults' stamp: 'hjo 1/4/2012 09:44'!
defaultScrollPane

	"Return a default object for instance variable scrollPane."
	| aScroll |
	aScroll := ScrollPane new.
	contentViewOfScrollPane := Morph new.
	contentViewOfScrollPane color: Color transparent.
	contentViewOfScrollPane extent: 1000@1000.
	aScroll scroller addMorph: contentViewOfScrollPane.
	contentViewOfScrollPane addMorph: self instanceVariablesMorph.
	contentViewOfScrollPane addMorph: self userClassButtonesMorph.
	^aScroll
! !

!PhileasFoggController methodsFor: 'defaults' stamp: 'hjo 1/7/2012 14:56'!
defaultSuperclassButton

	"Return a default object for instance variable superclassButton."
	^PluggableButtonMorph on: self getState: nil action: #goSuperclass label: #nameOfSuperclass! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:17'!
goSuperclass

	model goSuperclass! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:12'!
initialize

	super initialize.
	self model: PhileasFogg new.! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/17/2011 21:03'!
instanceVariablesMorph

	^instanceVariablesMorph ifNil: [
		instanceVariablesMorph:= TextMorph new.
		instanceVariablesMorph contents: model paragraphOfInstanceVariableNames.
 		]  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:18'!
model: aPhileasFogg 
  
	model ifNotNil: [ model breakDependents ].
	model := aPhileasFogg.
	model addDependent: self.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/18/2011 20:21'!
moveInstanceVariablesMorphBelowTopicClassNameMorph

	instanceVariablesMorph top: contentViewOfScrollPane top + 50.
	instanceVariablesMorph left: contentViewOfScrollPane left + 30.
! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/19/2011 17:55'!
moveScrollPaneToFitResetOfTheArea

	self scrollPane top: self classNameTextMorph bottom.
	self scrollPane left: self contentView left.
	self scrollPane width: self contentView width.
	self scrollPane height: self contentView bottom - self classNameTextMorph bottom.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/18/2011 20:23'!
moveUserClassButtonesMorphBelowInstanceVariablesMorph

	self userClassButtonesMorph top: self instanceVariablesMorph bottom + 50.
	self userClassButtonesMorph left: 0.! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:25'!
nameOfSuperclass

	^model nameOfSuperclassOfTopicClass ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/19/2011 17:57'!
reorganizeViews

	self moveScrollPaneToFitResetOfTheArea.
	self moveInstanceVariablesMorphBelowTopicClassNameMorph.
	self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
	self resizeUserClassButtonesMorphToFitButtons.

	contentViewOfScrollPane width: self scrollPane width.
	contentViewOfScrollPane height: self userClassButtonesMorph bottom.! !

!PhileasFoggController methodsFor: 'view organazing' stamp: 'hjo 11/19/2011 17:50'!
resizeUserClassButtonesMorphToFitButtons

	self userClassButtonesMorph width: (buttons isEmpty ifTrue: [30] ifFalse: [(buttons collect: #width) max]).
	self userClassButtonesMorph height: (buttons isEmpty ifTrue: [30] ifFalse: [(buttons collect: #height) sum]).! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2012 18:01'!
restoreHistory

	model restoreHistory! !

!PhileasFoggController methodsFor: 'accessing' stamp: 'hjo 1/4/2012 09:42'!
scrollPane

	^scrollPane setDefault: #defaultScrollPane for: self withSetter: #scrollPane:! !

!PhileasFoggController methodsFor: 'accessing' stamp: 'hjo 1/4/2012 09:42'!
scrollPane: anObject
		
	scrollPane := anObject! !

!PhileasFoggController methodsFor: 'accessing' stamp: 'hjo 1/7/2012 14:56'!
superclassButton

	^superclassButton setDefault: #defaultSuperclassButton for: self withSetter: #superclassButton:! !

!PhileasFoggController methodsFor: 'accessing' stamp: 'hjo 1/7/2012 14:58'!
superclassButton: aButtonMorph
		
	superclassButton := aButtonMorph! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:02'!
topicClass: aClass 

	model topicClass: aClass  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2011 11:19'!
update: aSymbol

	aSymbol = #topicClass ifTrue: [ 
		self changed: #nameOfSuperclass.
		classNameTextMorph contents: model nameOfTopicClass. 
		instanceVariablesMorph contents: model paragraphOfInstanceVariableNames.
		self moveInstanceVariablesMorphBelowTopicClassNameMorph.
		self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
		self createButtonList.
		self reorganizeViews.
		^self ].
	#pleaseRemoveAllUserButtons = aSymbol ifTrue: [
		userClassButtonesMorph removeAllMorphs.
		].
	Transcript show: aSymbol;cr;flush.  ! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 11/17/2011 21:03'!
userClassButtonesMorph

	^userClassButtonesMorph ifNil:
	[	|  lastButton |
		userClassButtonesMorph := Morph new.
		userClassButtonesMorph color: Color transparent.
		self moveUserClassButtonesMorphBelowInstanceVariablesMorph.
		self createButtonList.
		userClassButtonesMorph.
	]! !

!PhileasFoggController methodsFor: 'view making' stamp: 'hjo 1/2/2012 17:55'!
window

	window ifNil: [
		window := self contentView openInWindow.
		window model: self.
		self reorganizeViews.
		window setLabel: 'Phileas Fogg' ]  ! !

Object subclass: #PhileasFoggTranscriptor
	instanceVariableNames: 'topicClass model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:51'!
initialize

	super initialize.
	model := PhileasFogg new.! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:57'!
main
	Transcript clear.
	self transcriptLine: '- class name -'.
	self transcriptLine: model nameOfTopicClass.
	self transcriptLine: '- superclass name -'.
	self transcriptLine: model nameOfSuperclassOfTopicClass.
	self transcriptLine: '- instance variable names -'.
	model instanceVariableNamesOfTopicClass do: [ :each | self transcriptLine: each ].
	self transcriptLine: '- referencing classes -'.
	model classesReferencingTopicClass do: [ :each | self transcriptLine: each printString ].
	self transcriptLine: '- end -'.
	Transcript flush! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:15'!
model: aPhileasFogg 

	model := aPhileasFogg! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:50'!
topicClass: aClass 

	model topicClass: aClass! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:47'!
transcriptLine: aString
	^ Transcript
		nextPutAll: aString;
		cr! !

Object subclass: #UnderstandingSmalltalkSystem
	instanceVariableNames: 'confidenceLevelOfClasses confidenceLevelOfSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg-Understanding'!

!UnderstandingSmalltalkSystem methodsFor: 'accessing' stamp: 'hjo 12/19/2011 19:33'!
confidenceLevelOfClasses

	^confidenceLevelOfClasses setDefault: #defaultConfidenceLevelOfClasses for: self withSetter: #confidenceLevelOfClasses:! !

!UnderstandingSmalltalkSystem methodsFor: 'accessing' stamp: 'hjo 12/19/2011 19:42'!
confidenceLevelOfClasses: aDictionary
		
	confidenceLevelOfClasses := aDictionary! !

!UnderstandingSmalltalkSystem methodsFor: 'accessing' stamp: 'hjo 12/19/2011 19:34'!
confidenceLevelOfSelectors

	^confidenceLevelOfSelectors setDefault: #defaultConfidenceLevelOfSelectors for: self withSetter: #confidenceLevelOfSelectors:! !

!UnderstandingSmalltalkSystem methodsFor: 'accessing' stamp: 'hjo 12/19/2011 19:42'!
confidenceLevelOfSelectors: aDictionary
		
	confidenceLevelOfSelectors := aDictionary! !

!UnderstandingSmalltalkSystem methodsFor: 'defaults' stamp: 'hjo 12/19/2011 19:34'!
defaultConfidenceLevelOfClasses

	"Return a default object for instance variable confidenceLevelOfClasses."
	^Dictionary new! !

!UnderstandingSmalltalkSystem methodsFor: 'defaults' stamp: 'hjo 12/19/2011 19:34'!
defaultConfidenceLevelOfSelectors

	"Return a default object for instance variable confidenceLevelOfSelectors."
	^Dictionary new! !

!UnderstandingSmalltalkSystem methodsFor: 'defaults' stamp: 'hjo 12/19/2011 19:48'!
meaningOfLevel: anInteger

	^{'I am in panic'	. 'I conceptually know about it. (like read some reference)' . 'I can write experssion but with great stress'. 'I can write expression with ease'. 'I completely confident about it.' } at: anInteger! !

!UnderstandingSmalltalkSystem methodsFor: 'as yet unclassified' stamp: 'hjo 12/19/2011 19:41'!
setConfidenceLevelOfClasses: aClass to: anInteger

	self assert: [ #(1 2 3 4 5) includes: anInteger ] description:  'Not allowed level'.
	self confidenceLevelOfClasses at: aClass put: anInteger.! !

!UnderstandingSmalltalkSystem methodsFor: 'as yet unclassified' stamp: 'hjo 12/19/2011 19:39'!
setConfidenceLevelOfSelector: aSymbol to: anInteger

	self assert: [#(1 2 3 4 5) includes: anInteger] description: 'Not allowed level'.
	self confidenceLevelOfSelectors at: aSymbol put: anInteger.! !

Object subclass: #UndoRedo
	instanceVariableNames: 'items position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:43'!
add: anObject

	[self position < self items size] whileTrue: [self items removeLast].
	self items add: anObject.
	self position: self position +1.    ! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:39'!
canRedo

	^self position < self items size.! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:41'!
canUndo

	self items isEmpty ifTrue: [^false].
	self position = 0 ifTrue: [^false].
	^true.! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:42'!
currentItem

	^self position = 0 ifTrue: [nil] ifFalse: [self items at: self position].! !

!UndoRedo methodsFor: 'defaults' stamp: 'hjo 12/28/2011 15:32'!
defaultItems

	"Return a default object for instance variable items."
	^OrderedCollection new! !

!UndoRedo methodsFor: 'defaults' stamp: 'hjo 12/28/2011 15:33'!
defaultPosition

	"Return a default object for instance variable position."
	^0! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:39'!
doRedo

	self position: self position + 1! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:36'!
doUndo

	self position: self position -1    ! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:32'!
items

	^items setDefault: #defaultItems for: self withSetter: #items:! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
items: anOrderedCollection
		
	items := anOrderedCollection! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
position

	^position setDefault: #defaultPosition for: self withSetter: #position:! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
position: anInteger
		
	position := anInteger! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:38'!
redo

	self canRedo ifTrue: [self doRedo]! !

!UndoRedo methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 15:37'!
undo

	self canUndo ifTrue: [self doUndo]! !
